| NUC472_NUC442_BSP V3.04.000 The Board Support Package for NUC472/NUC442

Macros | Functions
I2C Exported Functions
NUC472/NUC442 Device Driver » I2C Driver » I2C Exported Constants
Collaboration diagram for I2C Exported Functions:

## Macros
#define | I2C_SET_CONTROL_REG(i2c, u8Ctrl)
| This macro sets the I2C control register at one time. More...
#define | I2C_START(i2c)
| This macro only set START bit to the control register of I2C module. More...
#define | I2C_STOP(i2c)
| This macro only set STOP bit to the control register of I2C module. More...
#define | I2C_WAIT_READY(i2c)
| This macro will return when I2C module is ready. More...
#define | I2C_GET_DATA(i2c)
| This macro returns the data stored in data register of I2C module. More...
#define | I2C_SET_DATA(i2c, u8Data)
| This macro writes the data to data register of I2C module. More...
#define | I2C_GET_STATUS(i2c)
| This macro returns the status of I2C module. More...
#define | I2C_GET_TIMEOUT_FLAG(i2c)
| This macro returns time-out flag. More...
#define | I2C_GET_WAKEUP_FLAG(i2c)
| This macro returns wakeup flag. More...
#define | I2C_CLEAR_WAKEUP_FLAG(i2c) ((i2c)->WKSTS |= I2C_WKSTS_WKIF_Msk )
| This macro clears wakeup flag. More...

## Functions
uint32_t | I2C_Open (I2C_T *i2c, uint32_t u32BusClock)
| This function make I2C module be ready and set the wanted bus clock. More...
void | I2C_Close (I2C_T *i2c)
| This function closes the I2C module. More...
void | I2C_ClearTimeoutFlag (I2C_T *i2c)
| This function clears the time-out flag. More...
void | I2C_Trigger (I2C_T *i2c, uint8_t u8Start, uint8_t u8Stop, uint8_t u8Si, uint8_t u8Ack)
| This function sets the control bit of the I2C module. More...
void | I2C_DisableInt (I2C_T *i2c)
| This function disables the interrupt of I2C module. More...
void | I2C_EnableInt (I2C_T *i2c)
| This function enables the interrupt (EI bit) of I2C module. More...
uint32_t | I2C_GetBusClockFreq (I2C_T *i2c)
| This function returns the real bus clock of I2C module. More...
uint32_t | I2C_SetBusClockFreq (I2C_T *i2c, uint32_t u32BusClock)
| This function sets bus frequency of I2C module. More...
uint32_t | I2C_GetIntFlag (I2C_T *i2c)
| This function gets the interrupt flag of I2C module. More...
uint32_t | I2C_GetStatus (I2C_T *i2c)
| This function returns the status of I2C module. More...
uint32_t | I2C_GetData (I2C_T *i2c)
| This function returns the data stored in data register of I2C module. More...
void | I2C_SetData (I2C_T *i2c, uint8_t u8Data)
| This function writes the data to data register of I2C module. More...
void | I2C_SetSlaveAddr (I2C_T *i2c, uint8_t u8SlaveNo, uint8_t u8SlaveAddr, uint8_t u8GCMode)
| Configure slave address and enable GC mode. More...
void | I2C_SetSlaveAddrMask (I2C_T *i2c, uint8_t u8SlaveNo, uint8_t u8SlaveAddrMask)
| Configure the mask of slave address. The corresponding address bit is "Don't Care". More...
void | I2C_EnableTimeout (I2C_T *i2c, uint8_t u8LongTimeout)
| This function enables timeout function and configures DIV4 function to support long timeout. More...
void | I2C_DisableTimeout (I2C_T *i2c)
| This function disables time-out function. More...
void | I2C_EnableWakeup (I2C_T *i2c)
| This function enables the wakeup function of I2C module. More...
void | I2C_DisableWakeup (I2C_T *i2c)
| This function disables the wakeup function of I2C module. More...

## Detailed Description

## Macro Definition Documentation

## ◆ I2C_CLEAR_WAKEUP_FLAG

#define I2C_CLEAR_WAKEUP_FLAG | ( |  | i2c | ) | ((i2c)->WKSTS |= I2C_WKSTS_WKIF_Msk )

This macro clears wakeup flag.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 131 of file i2c.h.

## ◆ I2C_GET_DATA

#define I2C_GET_DATA | ( |  | i2c | ) |

This macro returns the data stored in data register of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Data.

Definition at line 87 of file i2c.h.

## ◆ I2C_GET_STATUS

#define I2C_GET_STATUS | ( |  | i2c | ) |

This macro returns the status of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Status.

Definition at line 104 of file i2c.h.

## ◆ I2C_GET_TIMEOUT_FLAG

#define I2C_GET_TIMEOUT_FLAG | ( |  | i2c | ) |

This macro returns time-out flag.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Status.

Return values

  0 | Flag is not set.
  1 | Flag is set.

Definition at line 114 of file i2c.h.

## ◆ I2C_GET_WAKEUP_FLAG

#define I2C_GET_WAKEUP_FLAG | ( |  | i2c | ) |

This macro returns wakeup flag.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Status.

Return values

  0 | Flag is not set.
  1 | Flag is set.

Definition at line 124 of file i2c.h.

## ◆ I2C_SET_CONTROL_REG

#define I2C_SET_CONTROL_REG | ( |  | i2c,
|  |  | u8Ctrl
| ) |  |

This macro sets the I2C control register at one time.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8Ctrl | is the register value of I2C control register.

Returns
  none

Definition at line 55 of file i2c.h.

## ◆ I2C_SET_DATA

#define I2C_SET_DATA | ( |  | i2c,
|  |  | u8Data
| ) |  |

This macro writes the data to data register of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8Data | is the data which will be write to data register of I2C module.

Returns
  none

Definition at line 96 of file i2c.h.

## ◆ I2C_START

#define I2C_START | ( |  | i2c | ) |

This macro only set START bit to the control register of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 63 of file i2c.h.

## ◆ I2C_STOP

#define I2C_STOP | ( |  | i2c | ) |

This macro only set STOP bit to the control register of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 71 of file i2c.h.

## ◆ I2C_WAIT_READY

#define I2C_WAIT_READY | ( |  | i2c | ) |

This macro will return when I2C module is ready.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 79 of file i2c.h.

## Function Documentation

## ◆ I2C_ClearTimeoutFlag()

void I2C_ClearTimeoutFlag | ( | I2C_T * | i2c | ) |

This function clears the time-out flag.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 86 of file i2c.c.

## ◆ I2C_Close()

void I2C_Close | ( | I2C_T * | i2c | ) |

This function closes the I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 53 of file i2c.c.

## ◆ I2C_DisableInt()

void I2C_DisableInt | ( | I2C_T * | i2c | ) |

This function disables the interrupt of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 122 of file i2c.c.

## ◆ I2C_DisableTimeout()

void I2C_DisableTimeout | ( | I2C_T * | i2c | ) |

This function disables time-out function.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 289 of file i2c.c.

## ◆ I2C_DisableWakeup()

void I2C_DisableWakeup | ( | I2C_T * | i2c | ) |

This function disables the wakeup function of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 309 of file i2c.c.

## ◆ I2C_EnableInt()

void I2C_EnableInt | ( | I2C_T * | i2c | ) |

This function enables the interrupt (EI bit) of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 132 of file i2c.c.

## ◆ I2C_EnableTimeout()

void I2C_EnableTimeout | ( | I2C_T * | i2c,
|  | uint8_t | u8LongTimeout
| ) |  |

This function enables timeout function and configures DIV4 function to support long timeout.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8LongTimeout | Enable timeout counter input clock is divide by 4.

Returns
  none

Definition at line 274 of file i2c.c.

## ◆ I2C_EnableWakeup()

void I2C_EnableWakeup | ( | I2C_T * | i2c | ) |

This function enables the wakeup function of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  none

Definition at line 299 of file i2c.c.

## ◆ I2C_GetBusClockFreq()

uint32_t I2C_GetBusClockFreq | ( | I2C_T * | i2c | ) |

This function returns the real bus clock of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Actual I2C bus clock frequency.

Definition at line 142 of file i2c.c.

Here is the call graph for this function:

## ◆ I2C_GetData()

uint32_t I2C_GetData | ( | I2C_T * | i2c | ) |

This function returns the data stored in data register of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  I2C data.

Definition at line 193 of file i2c.c.

## ◆ I2C_GetIntFlag()

uint32_t I2C_GetIntFlag | ( | I2C_T * | i2c | ) |

This function gets the interrupt flag of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  Interrupt flag.

Return values

  0 | Flag is not set.
  1 | Flag is set.

Definition at line 173 of file i2c.c.

## ◆ I2C_GetStatus()

uint32_t I2C_GetStatus | ( | I2C_T * | i2c | ) |

This function returns the status of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.

Returns
  I2C status

Definition at line 183 of file i2c.c.

## ◆ I2C_Open()

uint32_t I2C_Open | ( | I2C_T * | i2c,
|  | uint32_t | u32BusClock
| ) |  |

This function make I2C module be ready and set the wanted bus clock.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u32BusClock | is the target bus speed of I2C module.

Returns
  Actual I2C bus clock frequency.

Definition at line 34 of file i2c.c.

Here is the call graph for this function:

## ◆ I2C_SetBusClockFreq()

uint32_t I2C_SetBusClockFreq | ( | I2C_T * | i2c,
|  | uint32_t | u32BusClock
| ) |  |

This function sets bus frequency of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u32BusClock | is the target bus speed of I2C module.

Returns
  Actual I2C bus clock frequency.

Definition at line 155 of file i2c.c.

Here is the call graph for this function:

## ◆ I2C_SetData()

void I2C_SetData | ( | I2C_T * | i2c,
|  | uint8_t | u8Data
| ) |  |

This function writes the data to data register of I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8Data | is the data which will be write to data register of I2C module.

Returns
  none

Definition at line 204 of file i2c.c.

## ◆ I2C_SetSlaveAddr()

void I2C_SetSlaveAddr | ( | I2C_T * | i2c,
|  | uint8_t | u8SlaveNo,
|  | uint8_t | u8SlaveAddr,
|  | uint8_t | u8GCMode
| ) |  |

Configure slave address and enable GC mode.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8SlaveNo | is the set number of salve address.
  [in] | u8SlaveAddr | is the slave address.
  [in] | u8GCMode | GC mode enable or not. Valid values are: I2C_GCMODE_ENABLE I2C_GCMODE_DISABLE

Returns
  none

Definition at line 219 of file i2c.c.

## ◆ I2C_SetSlaveAddrMask()

void I2C_SetSlaveAddrMask | ( | I2C_T * | i2c,
|  | uint8_t | u8SlaveNo,
|  | uint8_t | u8SlaveAddrMask
| ) |  |

Configure the mask of slave address. The corresponding address bit is "Don't Care".

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8SlaveNo | is the set number of salve address.
  [in] | u8SlaveAddrMask | is the slave address mask.

Returns
  none

Definition at line 247 of file i2c.c.

## ◆ I2C_Trigger()

void I2C_Trigger | ( | I2C_T * | i2c,
|  | uint8_t | u8Start,
|  | uint8_t | u8Stop,
|  | uint8_t | u8Si,
|  | uint8_t | u8Ack
| ) |  |

This function sets the control bit of the I2C module.

Parameters

  [in] | i2c | is the base address of I2C module.
  [in] | u8Start | sets START bit to I2C module.
  [in] | u8Stop | sets STOP bit to I2C module.
  [in] | u8Si | sets SI bit to I2C module.
  [in] | u8Ack | sets ACK bit to I2C module.

Returns
  none

Definition at line 100 of file i2c.c.